![https://https://i.imgur.com/VvQaP4U.png](https://i.imgur.com/ZRlrMtW.png)
![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/cWhKbMy.png)

### <p align="center">MagicHeim is a [Valheim](https://www.valheimgame.com/) mod that adds a new generation Classes System to the game.</p> 
<p align="center"></p>

## CLASSES

| Feature | Description                                               |
|:--------|:----------------------------------------------------------|
| Warrior | In development.                                           |
| Mage    | Call forth the power of elements to destroy your enemies. |
| Druid   | In development.                                           |

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/cWhKbMy.png)

# Overview

MagicHeim is a mod that adds classes and magic in Valheim. I am the dev of previous big magic mod: MagicOverhaul, and MagicHeim is basically MO v2.0 . Renewed with new systems / features, quality instead of quantity and other major changes.

In current plans each class have 25 active skills and 10 passives. I wanted to release this mod only when class amount will be at least 3, but im afraid that amount of bugs will be too much, so i decided to release it earlier. I will add more classes in future updates.

Close future plans; Finish Warrior + Druid classes. Add Class weapons + add "boss" skills for each of these classes.

Further plans: Add more classes (Assassin, Warlock?), add more skills, add more features.

What is working currently:

* Classes System (you can take Mage only at this moment since other classes are not finished)
* Class Skills
* Level System (you can get level by killing enemies or "eating" books)
* Skill Points (you can get skill points by leveling up)
* Skill Learn / Upgrade
* Every skill has tones of config options which are already serversynced
* Other configs not related to skills
* Skills are tested in multiplayer and seem to work with no problems

Im **SURE** that it will be a lot of bugs so please feel free to report all of them to me (discord link below). Also feel free to suggest your ideas. Mod is currently in active development so its not too late to change anything you want.



![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/cWhKbMy.png)

# How-to

<details>
  <summary><b><span style="color:aqua;font-weight:200;font-size:20px">
   Place an altar and take class:
</span></b></summary>

In order to take your first class you need to place a MagicHeim Altar. To do so you would need to use any admin / cheat tool to enable Debug Mode. Its done on purpose so that on servers only admins could place Altar on map.

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/lm1U0nV.png)
![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/qmWtl7W.png)
![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/72u1Kkh.png)

Then you can interact with Altar and take your first class:

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/zLMwvOK.png)

You can also hover on class Skills and watch a small video-previews:

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/BI6uCPo.png)

Press Change Class button in order to take your class:


![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/XIUZ3vH.png)
![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/46jnkPO.png)
</details>

<details>
  <summary><b><span style="color:aqua;font-weight:200;font-size:20px">
   Skillbook and Skills usage:
</span></b></summary>

Press K button (default) in order to open Skillbook:

Active skills tab:
![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/glh2Kte.png)
Passive skills tab:
![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/kepSrvf.png)


By clicking on small "Arrow" button you can learn / upgrade skills if you have enough resources to do so (and required+ level)

In order to use skills you need to drag skill you want into SkillPanel. To do so click on skill Icon in Skillbook and then click on desired skill slot on panel:

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/WwFzafD.png)

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/hEeKbHs.png)

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/OEp5Deb.png)

To use skills hold Left Alt + Skill hotkey. +- half skills want you to HOLD buttons and not just click them (chargable, precast skills)

</details>


<details>
  <summary><b><span style="color:aqua;font-weight:200;font-size:20px">
   Leveling:
</span></b></summary>

In order to level up you need to kill enemies or "eat" books. Books are dropped by enemies with low chance. Exp Map is set in config for each creature.

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/JCyAbBs.png)

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/ELEQeRY.png)

To see your current / needed exp you can write /exp in chat:

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/E6TXtZA.png)

</details>

<details>
  <summary><b><span style="color:aqua;font-weight:200;font-size:20px">
   Settings:
</span></b></summary>

In order to change MH Hotkeys / Usage of Left Alt / Skillbook Hotkey press Escape and go into Vanilla settings tab:

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/YXz15ki.png)

In MagicHeim tab you will find settings you need:

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/WrB738B.png)


</details>

<details>
  <summary><b><span style="color:aqua;font-weight:200;font-size:20px">
   Cheat Commands:
</span></b></summary>

In order to use cheat commands you need to enable Debug Mode. Then you can use following commands in chat:


**/mh exp NUMBER** - adds exp to your character

**/mh cd** - resets all cooldowns

</details>

![https://i.imgur.com/cWhKbMy.png](https://i.imgur.com/cWhKbMy.png)

# Manual Install


>Download the latest copy of Bepinex per author's instructions.

>Place the MagicHeim Folder inside of the "BepInEx\plugins\" folder.

## Known Issues

Testing...


<details>
  <summary><b><span style="color:aqua;font-weight:200;font-size:20px">
    Patchnotes
</span></b></summary>

| Version Number | Change(s)                                                                                                                                      |
|:---------------|:-----------------------------------------------------------------------------------------------------------------------------------------------|
| v1.0.0         | Release Version.                                                                                                                               |
| v1.1.0         | Now UI also saves its Scale (Size)<br/>Now on scaling UI its using its aspect ratio so X = Y (much easier to scale now).<br/>Few misc bugfixes |
| v1.2.0         | Updated Settings UI. Now you can assign additional hotkey usage + hotkey itself for each spell particular<br/>Druid ready 50%                  |
| v1.2.2         | Updated for new Valheim version                                                                                                                |
| v1.2.3         | Updated for new Valheim version                                                                                                                |
| v1.2.4         | Updated for new Valheim version                                                                                                                |
</details>


For Questions or Comments, find KG in the Odin Plus
Team Discord:
[![https://i.imgur.com/XXP6HCU.png](https://i.imgur.com/XXP6HCU.png)](https://discord.gg/5gXNxNkUBt)